## musescore 1.3+dfsg

=== Makefile ===
#=============================================================================
#  Mscore
#  Linux Music Score Editor
#  $Id:$
#
#  Copyright (C) 2002-2007 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

REVISION  = `cat mscore/mscore/revision.h`
CPUS      = `grep -c processor /proc/cpuinfo`

PREFIX    = "/usr/local"
#VERSION   = "1.2r${REVISION}"
VERSION   = 1.3

ROOT=`pwd`

release:
	if test ! -d build;                              \
         then                                          \
            mkdir build;                               \
            cd build;                                  \
            cmake -DCMAKE_BUILD_TYPE=RELEASE	       \
            	  -DCMAKE_INSTALL_PREFIX="${PREFIX}" \
            	   ../mscore; 			       \
            make lrelease;                             \
            make -j ${CPUS};                           \
         else                                          \
            echo "build directory does already exist, please remove first with 'make clean'"; \
         fi;

debug:
	if test ! -d build;                              \
         then                                          \
            mkdir build;                               \
            cd build;                                  \
            cmake -DCMAKE_BUILD_TYPE=DEBUG	       \
            	  -DCMAKE_INSTALL_PREFIX="${PREFIX}" \
            	   ../mscore; 			       \
            make lrelease;                             \
            make -j ${CPUS};                           \
         else                                          \
            echo "build directory does already exist, please remove first with 'make clean'";       \
         fi

#
#  win32
#     cross compile windows package
#     NOTE: there are some hardcoded path in CMake - files
#           will probably only work on my setup (ws)
#
win32:
	if test ! -d win32build;                         \
         then                                          \
            mkdir win32build;                          \
      	if test ! -d win32install;                 \
               then                                    \
                  mkdir win32install;                  \
            fi;                                        \
            cd win32build;                             \
            cmake -DCMAKE_TOOLCHAIN_FILE=../mscore/cmake/mingw32.cmake -DCMAKE_INSTALL_PREFIX=../win32install -DCMAKE_BUILD_TYPE=DEBUG  ../mscore; \
            make lrelease;                             \
            make -j ${CPUS};                           \
            make install;                              \
            make package;                              \
         else                                          \
            echo "build directory win32build does alread exist, please remove first"; \
         fi

#
# clean out of source build
#

clean:
	-rm -rf build
	-rm -rf win32build win32install

#
# dist
#     create source distribution
#     - get current version from sourceforge
#     - remove .svn directories
#     - tar
#     - untar & test build
#

dist:
	-rm -rf mscore.dist
	mkdir mscore.dist
	cd mscore.dist; svn co https://mscore.svn.sourceforge.net/svnroot/mscore/trunk mscore-${VERSION}
	cd mscore.dist; find . -name .svn -print0 | xargs -0 /bin/rm -rf
	cd mscore.dist; tar cvfj mscore-${VERSION}.tar.bz2 mscore-${VERSION}
	mv mscore.dist/mscore-${VERSION}.tar.bz2 .

testdist:
	tar xvofj mscore-${VERSION}.tar.bz2
	cd mscore-${VERSION}; make release

revision:
	@svnversion -n  > mscore/mscore/revision.h

version: revision
	@echo ${VERSION}

install:
	cd build; make install

#
#  linux
#     linux binary package build
#
unix:
	if test ! -d linux;                          \
         then                                      \
            mkdir linux;                           \
            cd linux; \
            cmake -DCMAKE_BUILD_TYPE=RELEASE  ../mscore; \
            make -j${CPUS} -f Makefile;            \
            make package;                          \
         else                                      \
            echo "build directory linux does alread exist, please remove first";  \
         fi

=== mscore/CMakeLists.txt ===
#=============================================================================
#  Mscore
#  Linux Music Score Editor
#  $Id:$
#
#  Copyright (C) 2002-2009 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

project(mscore)
CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0)

cmake_policy(SET CMP0003 NEW)

# for debugging the make system uncomment next line:
# set(CMAKE_VERBOSE_MAKEFILE ON)

set(MSCORE_UNSTABLE  FALSE)               # mark as unstable

set(GCC_VISIBILITY TRUE)                  # requires gcc 4.x?
set(HAS_AUDIOFILE TRUE)                   # requires libsndfile
set(OSC           TRUE)                   # osc remote control

set(BUILD_SCRIPTGEN TRUE)                 #Generate Qt script bindings. (collides with qtscriptgenerator project on several distrib)
set(STATIC_SCRIPT_BINDINGS FALSE)
set(USE_SSE FALSE)

if (MINGW)
      set(GCC_VISIBILITY FALSE)           # we use gcc 3.6
      set(STATIC_SCRIPT_BINDINGS TRUE)
endif (MINGW)

if (APPLE)
      set(HAS_AUDIOFILE TRUE)            # requires libsndfile
      set(STATIC_SCRIPT_BINDINGS TRUE)
      
     set (CMAKE_CXX_COMPILER   clang++)
      # Currently, just 'ppc', 'i386' or 'ppc i386' are useful architectures,
      # because the Flash-Player is not yet available as a 64-bit version.
      # Flash is required for displaying the videos of MuseScore-Connect.
      # See http://qt.gitorious.org/qt/pages/Qt470KnownIssues
      # Since 10.6+ only runs on intel, just set it to i386.
      set(CMAKE_OSX_ARCHITECTURES x86_64)

      # Adjust and uncomment this variable, if you target a different version
      # of MacOSX.
      # set(CMAKE_OSX_SYSROOT /Developer/SDKs/MacOSX10.6.sdk)

      set(CMAKE_OSX_DEPLOYMENT_TARGET 10.4)      #min version required
      
      find_library(AudioToolboxFW NAMES AudioToolbox)
      find_library(AudioUnitFW NAMES AudioUnit)
      find_library(CoreAudioFW NAMES CoreAudio)
      find_library(CoreMidiFW NAMES CoreMIDI)
      find_library(SystemConfigurationFW NAMES SystemConfiguration)
      find_library(CoreServicesFW NAMES CoreServices)
      set(OsxFrameworks ${AudioToolboxFW} ${AudioUnitFW} ${CoreAudioFW} ${CoreMidiFW} ${SystemConfigurationFW} ${CoreServicesFW})
endif (APPLE)

set(CMAKE_INCLUDE_CURRENT_DIR TRUE)
set(CMAKE_BUILD_WITH_INSTALL_RPATH ON)
set(CMAKE_SKIP_RULE_DEPENDENCY TRUE)

# The Mscore version number.
SET(Mscore_VERSION_MAJOR  "1")
SET(Mscore_VERSION_MINOR  "3")
SET(Mscore_VERSION_PATCH  "0")

SET(Mscore_VERSION       "${Mscore_VERSION_MAJOR}.${Mscore_VERSION_MINOR}")
#SET(Mscore_VERSION_FULL  "${Mscore_VERSION}.${Mscore_VERSION_PATCH}")
SET(Mscore_VERSION_FULL  "${Mscore_VERSION}")

if (MINGW OR APPLE)
  if(MINGW)
      SET(Mscore_INSTALL_NAME  "")
      SET(Mscore_SHARE_NAME    "./")
  else(MINGW)
      SET(Mscore_INSTALL_NAME  "Contents/Resources/")
      SET(Mscore_SHARE_NAME    "mscore.app/")
  endif(MINGW)
else (MINGW OR APPLE)
      SET(Mscore_INSTALL_NAME  "mscore-${Mscore_VERSION}/")
      SET(Mscore_SHARE_NAME    "share/")
endif (MINGW OR APPLE)

include ( ${PROJECT_SOURCE_DIR}/cmake/UsePkgConfig1.cmake )
include ( ${PROJECT_SOURCE_DIR}/cmake/TargetDoc.cmake)

##
##  look for Qt4
##

set(QT_MIN_VERSION "4.6.0")
set(QT_USE_QTXML     TRUE)
set(QT_USE_QTSVG     TRUE)
set(QT_USE_QTNETWORK TRUE)
set(QT_USE_QTUITOOLS TRUE)
set(QT_USE_QTDESIGNER TRUE)
set(QT_USE_QTSCRIPT   TRUE)
set(QT_USE_QTSCRIPTTOOLS   TRUE)
set(QT_USE_QTWEBKIT   TRUE)

find_package(Qt4 "4.6")

if (NOT QT4_FOUND)
      message(FATAL_ERROR "Fatal error: QT (version >= 4.6.0) required."
         " Cmake tries to detect QT4 by searching for 'qmake' in your PATH."
         "If you have QT4 installed, make sure qmake is found in your PATH. "
         "If you compiled QT4 yourself make sure your new qmake ist found"
         " _first_ in your PATH."
         )
else (NOT QT4_FOUND)
      message("Qt lib found at ${QT_LIBRARY_DIR}")
endif (NOT QT4_FOUND)


# Set QT_QTSCRIPT_INCLUDE_DIR
FIND_PATH(QT_QTSCRIPT_INCLUDE_DIR QtScript
   PATHS
   ${QT_INCLUDE_DIR}/QtScript
   ${QT_LIBRARY_DIR}/QtScript.framework/Headers
   NO_DEFAULT_PATH
   )

# Set QT_QTSCRIPT_LIBRARY (for cmake 2.4)
#FIND_LIBRARY(QT_QTSCRIPT_LIBRARY_RELEASE NAMES QtScript QtScript4 PATHS ${QT_LIBRARY_DIR}        NO_DEFAULT_PATH)
#FIND_LIBRARY(QT_QTSCRIPT_LIBRARY_DEBUG   NAMES QtScript QtScript_debug QtScriptd4 PATHS ${QT_LIBRARY_DIR} NO_DEFAULT_PATH)
#_QT4_ADJUST_LIB_VARS(QTSCRIPT)

# Set QT_QTSCRIPT_TOOLS_LIBRARY (apparently still needed on Ubuntu 9.10 - cmake 2.6.4)
if (NOT MINGW AND NOT APPLE)
FIND_LIBRARY(QT_QTSCRIPT_TOOLS_LIBRARY_RELEASE NAMES QtScriptTools QtScriptTools4 PATHS ${QT_LIBRARY_DIR}        NO_DEFAULT_PATH)
FIND_LIBRARY(QT_QTSCRIPT_TOOLS_LIBRARY_DEBUG   NAMES QtScriptTools QtScriptTools_debug QtScriptToolsd4 PATHS ${QT_LIBRARY_DIR} NO_DEFAULT_PATH)
_QT4_ADJUST_LIB_VARS(QTSCRIPT_TOOLS)
endif (NOT MINGW AND NOT APPLE)

include(${QT_USE_FILE})

##
## alsa >= 1.0.0
##

if (APPLE OR MINGW)
	message("Disabling ALSA support due to OS X or MINGW build.")
      set (USE_ALSA 0)
      set (HAS_MIDI 1)
else (APPLE OR MINGW)
      PKGCONFIG (alsa 1.0.0 ALSA_INCDIR ALSA_LIBDIR ALSA_LIB ALSA_CPP )
      if (NOT ALSA_INCDIR)
            message(FATAL_ERROR "Fatal error: ALSA >= 1.0.0 required")
      else (NOT ALSA_INCDIR)
	      message("Alsa detected.")
            set (USE_ALSA 1)
            set (HAS_MIDI 1)
      endif (NOT ALSA_INCDIR)
endif (APPLE OR MINGW)


##
## find jack >= JACK_MIN_VERSION
##

SET(JACK_LONGNAME "jack (jack audio connection kit)")
SET(JACK_MIN_VERSION "0.98.0")

SET(BUILD_JACK AUTO CACHE STRING "Build with support for ${JACK_LONGNAME}. jack >= ${JACK_MIN_VERSION} will be needed. [ON/OFF/AUTO]")
IF(BUILD_JACK)
     IF(MINGW)
           set (USE_JACK 1)
           IF("$ENV{PROCESSOR_ARCHITEW6432}" STREQUAL "")
              IF($ENV{PROCESSOR_ARCHITECTURE} STREQUAL "x86")
                 # "pure" 32-bit environment
                 set (JACK_INCDIR "C:/Program Files/Jack/includes")
                 set (JACK_LIB "C:/Program Files/Jack/lib/libjack.a")
              ELSE($ENV{PROCESSOR_ARCHITECTURE} STREQUAL "x86")
                 # "pure" 64-bit environment
                 set (JACK_INCDIR "C:/Program Files (x86)/Jack/includes")
                 set (JACK_LIB "C:/Program Files (x86)/Jack/lib/libjack.a")
              ENDIF($ENV{PROCESSOR_ARCHITECTURE} STREQUAL "x86")
           ELSE("$ENV{PROCESSOR_ARCHITEW6432}" STREQUAL "")
              IF("$ENV{PROCESSOR_ARCHITECTURE}" STREQUAL "x86")
                 # 32-bit program running with an underlying 64-bit environment
                 set (JACK_INCDIR "C:/Program Files (x86)/Jack/includes")
                 set (JACK_LIB "C:/Program Files (x86)/Jack/lib/libjack.a")
              ELSE("$ENV{PROCESSOR_ARCHITECTURE}" STREQUAL "x86")
                 # theoretically impossible case...
              ENDIF("$ENV{PROCESSOR_ARCHITECTURE}" STREQUAL "x86")
           ENDIF("$ENV{PROCESSOR_ARCHITEW6432}" STREQUAL "")

     ELSE(MINGW)
           PKGCONFIG(jack ${JACK_MIN_VERSION} JACK_INCDIR JACK_LIBDIR JACK_LIB JACK_CPP)
           IF(JACK_INCDIR)
                 MESSAGE(STATUS "${JACK_LONGNAME} >= ${JACK_MIN_VERSION} found")
                 SET(USE_JACK 1)
           ELSE(JACK_INCDIR)
                 MESSAGE(STATUS "${JACK_LONGNAME} >= ${JACK_MIN_VERSION} not found")
                 IF(NOT BUILD_JACK STREQUAL AUTO)
                       MESSAGE(SEND_ERROR "Error: jack support requested but not found (BUILD_JACK=${BUILD_JACK})")
                 ENDIF()
           ENDIF(JACK_INCDIR)
     ENDIF(MINGW)
ELSE(BUILD_JACK)
     MESSAGE(STATUS "${JACK_LONGNAME} support disabled")
ENDIF(BUILD_JACK)


##
## portaudio
##

if (MINGW)
      set ( USE_PORTAUDIO 1 )
      set ( USE_PORTMIDI  1 )
else (MINGW)
   PKGCONFIG (portaudio-2.0 19 PORTAUDIO_INCDIR PORTAUDIO_LIBDIR PORTAUDIO_LIB PORTAUDIO_CPP )
   if (PORTAUDIO_INCDIR)
	message("portaudio detected ${PORTAUDIO_INCDIR} ${PORTAUDIO_LIBDIR} ${PORTAUDIO_LIB}")
      set ( USE_PORTAUDIO 1 )
   else (PORTAUDIO_INCDIR)
      message("optional package portaudio-2.0 Version 19 not found (package portaudio19-dev)\n")
      set ( USE_PORTAUDIO 0 )
   endif (PORTAUDIO_INCDIR)
   if (APPLE)
      set ( USE_PORTMIDI  1 )
   else (APPLE)
      set (USE_PORTMIDI 0)
   endif (APPLE)
endif (MINGW)

##
## produce config.h file
##
configure_file (
      ${PROJECT_SOURCE_DIR}/config.h.in
      ${PROJECT_BINARY_DIR}/config.h
      )

#
#  create precompiled header file
#
add_custom_command(
   OUTPUT ${PROJECT_BINARY_DIR}/all.h
   COMMAND ${CMAKE_COMMAND}
   ARGS -E copy ${PROJECT_SOURCE_DIR}/all.h ${PROJECT_BINARY_DIR}/all.h
   DEPENDS ${PROJECT_SOURCE_DIR}/all.h
   WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
   )

set(CMAKE_CXX_FLAGS_DEBUG   "-g")
set(CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG")

if (CMAKE_BUILD_TYPE STREQUAL "DEBUG")
      if (MINGW)
            set(FLAGS -DQT_DEBUG -DQT_DLL)
      else (MINGW)
      	if(APPLE)
            	set (FLAGS -O0 -DQT_DEBUG)
            else (APPLE)
            	set (FLAGS -DQT_DEBUG)
            endif(APPLE)
      endif (MINGW)
else (CMAKE_BUILD_TYPE STREQUAL "DEBUG")
      if (MINGW)
            set(FLAGS -O2 -DNDEBUG -DQT_DLL -DQT_NO_DEBUG)
      else (MINGW)
            set(FLAGS -O2 -DNDEBUG -DQT_NO_DEBUG)
      endif (MINGW)
endif (CMAKE_BUILD_TYPE STREQUAL "DEBUG")

MESSAGE( STATUS "CMAKE_CXX_COMPILER_ID:" ${CMAKE_CXX_COMPILER_ID})


add_custom_command(
 OUTPUT ${PROJECT_BINARY_DIR}/all.h.gch
 COMMAND ${CMAKE_CXX_COMPILER}
   -x c++-header -g  ${FLAGS}
   -I${QT_HEADERS_DIR}
   -o all.h.gch all.h
 DEPENDS ${PROJECT_BINARY_DIR}/all.h
 WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
 )
set (PCH ${PROJECT_BINARY_DIR}/all.h.gch)


ADD_CUSTOM_TARGET(mops1 DEPENDS ${PROJECT_BINARY_DIR}/all.h)
ADD_CUSTOM_TARGET(mops2 DEPENDS ${PCH})


if (NOT MINGW AND NOT APPLE)
      install( FILES packaging/mscore.desktop DESTINATION share/applications)
endif (NOT MINGW AND NOT APPLE)

subdirs (al awl bww2mxml osdabzip rtf2html mscore share manual demos
      singleapp fluid)

if (BUILD_SCRIPTGEN)
      subdirs (scriptgen)
endif (BUILD_SCRIPTGEN)

if (MINGW OR APPLE)
      subdirs (portmidi)
endif (MINGW OR APPLE)

if (OSC)
      subdirs (ofqf)
endif (OSC)

include_directories(
   ${PROJECT_SOURCE_DIR}
   ${PROJECT_SOURCE_DIR}/mscore
   ${PROJECT_BINARY_DIR}
   ${PROJECT_BINARY_DIR}/mscore
   ${ALSA_INCDIR}
   ${JACK_INCDIR}
   ${PORTAUDIO_INCDIR}
)

##
## create package target
##

include (InstallRequiredSystemLibraries)

  SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "MuseScore is a full featured WYSIWYG score editor")
  SET(CPACK_PACKAGE_VENDOR "Werner Schweer and Others")
  SET(CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/COPYING")
  SET(CPACK_RESOURCE_FILE_LICENSE    "${PROJECT_SOURCE_DIR}/COPYING")

  SET(CPACK_PACKAGE_VERSION_MAJOR "${Mscore_VERSION_MAJOR}")
  SET(CPACK_PACKAGE_VERSION_MINOR "${Mscore_VERSION_MINOR}")
  SET(CPACK_PACKAGE_VERSION_PATCH "${Mscore_VERSION_PATCH}")
  SET(CPACK_PACKAGE_INSTALL_DIRECTORY "MuseScore ${Mscore_VERSION_MAJOR}.${Mscore_VERSION_MINOR}")

  SET(CPACK_NSIS_COMPRESSOR "/FINAL /SOLID lzma")

  IF(MINGW)
      SET(CPACK_PACKAGE_INSTALL_DIRECTORY "MuseScore")
      SET(CPACK_PACKAGE_NAME    "MuseScore")
      # There is a bug in NSI that does not handle full unix paths properly. Make
      # sure there is at least one set of four (4) backlasshes.

=== mscore/al/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#  $Id:$
#
#  Copyright (C) 2009 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

include (${PROJECT_SOURCE_DIR}/cmake/gch.cmake)

set (al_src
   al.cpp
   dsp.cpp
   xml.cpp
   tempo.cpp
   sig.cpp
   pos.cpp
   fraction.cpp
   )

if (USE_SSE)
      set(al_src ${al_src} dspSSE.cpp dspXMM.cpp)
endif (USE_SSE)

add_library(al STATIC
   ${PROJECT_BINARY_DIR}/all.h
   ${PCH}
   ${al_src}
   )

set_source_files_properties(
   dsp.cpp xml.cpp tempo.cpp sig.cpp pos.cpp fraction.cpp
   PROPERTIES COMPILE_FLAGS "-include ${PROJECT_BINARY_DIR}/all.h -g -Wall -Wextra -Winvalid-pch"
   )

set_source_files_properties(dspSSE.cpp
   PROPERTIES COMPILE_FLAGS "-msse -x assembler"
   )

set_source_files_properties(dspXMM.cpp
   PROPERTIES COMPILE_FLAGS "-msse"
   )

ADD_DEPENDENCIES(al mops1)
ADD_DEPENDENCIES(al mops2)

=== mscore/awl/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#  $Id:$
#
#  Copyright (C) 2002-2006 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

include (${PROJECT_SOURCE_DIR}/cmake/gch.cmake)

QT4_WRAP_CPP (mocs
      aslider.h
      knob.h
      panknob.h
      volknob.h
      midipanknob.h
      colorlabel.h
      slider.h
      volslider.h
      mslider.h
      pitchedit.h
      pitchlabel.h
#      posedit.h
      poslabel.h
      denomspinbox.h
      )

add_library (
      awl STATIC
      ${PROJECT_BINARY_DIR}/all.h
      ${PCH}
      ${mocs}
      aslider.cpp
      knob.cpp
      panknob.cpp
      volknob.cpp
      midipanknob.cpp
      colorlabel.cpp
      slider.cpp
      volslider.cpp
      mslider.cpp
      pitchedit.cpp
      pitchlabel.cpp
      poslabel.cpp
#      posedit.cpp
      utils.cpp
      denomspinbox.cpp
      )

set_target_properties( awl
   PROPERTIES COMPILE_FLAGS
      "-include ${PROJECT_BINARY_DIR}/all.h -g -Wall -Wextra -Winvalid-pch"
   )

ADD_DEPENDENCIES(awl mops1)
ADD_DEPENDENCIES(awl mops2)

if (NOT MINGW AND NOT APPLE)
QT4_WRAP_CPP (mocs2
      aslider.h
      knob.h
      panknob.h
      volknob.h
      midipanknob.h
      awlplugin.h
      colorlabel.h
      slider.h
      volslider.h
      mslider.h
      denomspinbox.h
      pitchedit.h
      pitchlabel.h
      )

add_library (
      awlplugin SHARED
      ${PROJECT_BINARY_DIR}/all.h
      ${PCH}
      ${mocs2}
      awlplugin.cpp
      aslider.cpp
      knob.cpp
      panknob.cpp
      volknob.cpp
      midipanknob.cpp
      colorlabel.cpp
      slider.cpp
      volslider.cpp
      mslider.cpp
      denomspinbox.cpp
      pitchedit.cpp
      pitchlabel.cpp
      utils.cpp
      )

##  "-D_GNU_SOURCE -D_REENTRANT -DHAVE_CONFIG_H -DQT_PLUGIN -DQT_SHARED -DQT_NO_DEBUG -include ${PROJECT_SOURCE_DIR}/all.h"

set_target_properties( awlplugin
      PROPERTIES
         COMPILE_FLAGS
            "-D_GNU_SOURCE -D_REENTRANT -DHAVE_CONFIG_H -DQT_PLUGIN -DQT_SHARED -DQT_NO_DEBUG -include ${PROJECT_SOURCE_DIR}/all.h"
      )

install( TARGETS awlplugin DESTINATION ${QT_PLUGINS_DIR}/designer/ )

add_executable(ltest ltest.cpp)
target_link_libraries (ltest awlplugin ${QT_LIBRARIES})


endif (NOT MINGW AND NOT APPLE)

=== mscore/bww2mxml/CMakeLists.txt ===
#=============================================================================
#  BWW to MusicXML converter
#  Part of MusE Score
#  Linux Music Score Editor
#  $Id: CMakeLists.txt 3882 2011-01-12 15:20:33Z lasconic $
#
#  Copyright (C) 2002-2010 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

add_library(bww STATIC
   lexer.cpp
   parser.cpp
   symbols.cpp
   writer.cpp
   )

if (NOT MINGW AND NOT APPLE)
add_executable(bww2mxml
   lexer.cpp
   main.cpp
   mxmlwriter.cpp
   parser.cpp
   symbols.cpp
   writer.cpp
   )

target_link_libraries(bww2mxml
   ${QT_LIBRARIES}
   )
endif (NOT MINGW AND NOT APPLE)

=== mscore/demos/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#  $Id:$
#
#  Copyright (C) 2002-2008 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

install(FILES
      sarabande.xml
      adeste.mscx
      bach-bc2.mscx
      inv1.mscx
      inv4.mscx
      inv6.mscx
      inv10.mscx
      inv13.mscx
      praeludium1.mscx
      prelude.mscx
      promenade.mscx
      scales.mscx
      sonata16.mscx
      italian-1.mscz
      golliwogg.mscx
      Estudio-No1-Tarrega.mscx
      PlanxtyCarolan.mscx
      wtc1fuga5.mscz
      schnee.mscz
      sarabande-gfh.mscz
      All_Dudes.mscz
      Triumph.mscz
      Reunion.mscz
      DESTINATION ${Mscore_SHARE_NAME}${Mscore_INSTALL_NAME}demos
      )

=== mscore/fluid/CMakeLists.txt ===
#=============================================================================
#  Mscore
#  Linux Music Score Editor
#  $Id:$
#
#  Copyright (C) 2007 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

include (${PROJECT_SOURCE_DIR}/cmake/gch.cmake)

add_library (fluid STATIC
  ${PROJECT_BINARY_DIR}/all.h
  ${PCH}
  dsp.cpp fluid.cpp voice.cpp chan.cpp sfont.cpp chorus.cpp
  conv.cpp gen.cpp mod.cpp rev.cpp tuning.cpp
  )

set_target_properties( fluid
   PROPERTIES COMPILE_FLAGS "-include ${PROJECT_BINARY_DIR}/all.h -g -Wall -Wextra -Winvalid-pch"
   )

ADD_DEPENDENCIES(fluid mops1)
ADD_DEPENDENCIES(fluid mops2)

=== mscore/manual/CMakeLists.txt ===
#=============================================================================
#  Mscore
#  Linux Music Score Editor
#  $Id:$
#
#  Copyright (C) 2002-2008 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

install(FILES
      MuseScore-da.pdf
      MuseScore-de.pdf
      MuseScore-en.pdf
      MuseScore-es.pdf
      MuseScore-fi.pdf
      MuseScore-fr.pdf
      MuseScore-gl.pdf
      MuseScore-hu.pdf
      MuseScore-it.pdf
      MuseScore-ja.pdf
      MuseScore-nb.pdf
      MuseScore-nl.pdf
      MuseScore-pl.pdf
      MuseScore-pt_BR.pdf
      MuseScore-ro.pdf
      MuseScore-ru.pdf
      MuseScore-zh_CN.pdf
      DESTINATION ${Mscore_SHARE_NAME}${Mscore_INSTALL_NAME}man
      )

=== mscore/mscore/CMakeLists.txt ===
#=============================================================================
#  MuseScore
#  Linux Music Score Editor
#  $Id:$
#
#  Copyright (C) 2002-2012 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

include (${PROJECT_SOURCE_DIR}/cmake/gch.cmake)


if (NOT MINGW)
#
#     set library search path for runtime linker to load the same
#     qt libraries as we used at compile time
#
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,-rpath,${QT_LIBRARY_DIR}")
endif (NOT MINGW)


SET_SOURCE_FILES_PROPERTIES(revision.h PROPERTIES GENERATED TRUE)

include_directories(
      ${CMAKE_CURRENT_BINARY_DIR}
      ${PROJECT_SOURCE_DIR}
      ${PROJECT_SOURCE_DIR}/scriptdebug
      ${PROJECT_SOURCE_DIR}/osdabzip
      ${PROJECT_SOURCE_DIR}/fluid
      ${PROJECT_SOURCE_DIR}/bww2mxml
      )

QT4_WRAP_UI (ui_headers
      insertmeasuresdialog.ui barline.ui chord.ui chordrest.ui editinstrument.ui editstyle.ui
      edittempo.ui element.ui hairpin.ui instrdialog.ui measure.ui measuresdialog.ui
      note.ui page.ui pagesettings.ui partedit.ui playpanel.ui prefsdialog.ui
      measureproperties.ui segment.ui text.ui textpalette.ui timedialog.ui
      symboldialog.ui dynamic.ui tuplet.ui shortcutcapturedialog.ui slurtie.ui
      slur.ui editdrumset.ui editstaff.ui line.ui linesegment.ui
      voltaproperties.ui chordproperties.ui restproperties.ui
      jumpproperties.ui markerproperties.ui boxproperties.ui
      instrwizard.ui timesigwizard.ui newwizard.ui aboutbox.ui
      chordedit.ui transposedialog.ui tempoproperties.ui importmidi.ui
      lineproperties.ui excerptsdialog.ui lyrics.ui stafftext.ui
      imageproperties.ui tupletdialog.ui tupletproperties.ui
      glissandoprop.ui articulation.ui metaedit.ui palette.ui textproperties.ui
      dynamicproperties.ui textline.ui slurproperties.ui inspector.ui
      select.ui synthcontrol.ui splitstaff.ui cellproperties.ui beam.ui keyedit.ui
      harmonyedit.ui selectinstr.ui tremolo.ui
      )

QT4_WRAP_CPP (mocs
      scoreview.h editinstrument.h editstyle.h edittempo.h instrdialog.h inspector.h
      mscore.h navigator.h pagesettings.h palette.h partedit.h playpanel.h
      preferences.h measureproperties.h preview.h score.h seq.h textpalette.h textstyle.h
      timedialog.h symboldialog.h shortcutcapturedialog.h simplebutton.h
      greendotbutton.h recordbutton.h editdrumset.h editstaff.h
      voltaproperties.h chordproperties.h restproperties.h
      jumpproperties.h markerproperties.h boxproperties.h newwizard.h
      transposedialog.h chordedit.h tempotext.h importmidi.h textline.h
      excerptsdialog.h stafftext.h image.h tuplet.h glissando.h
      script.h articulation.h metaedit.h magbox.h voiceselector.h
      text.h sccursor.h dynamics.h undo.h textproperties.h
      slurproperties.h select.h synthcontrol.h drumroll.h pianoroll.h piano.h ruler.h
      pianoscene.h splitstaff.h scoretab.h keyedit.h keycanvas.h harmonyedit.h
      harmonycanvas.h updatechecker.h webpage.h
      )

QT4_ADD_RESOURCES (qrc_files mscore.qrc)

set (AUDIO "")
if (MINGW)
      set (resource_file ${PROJECT_BINARY_DIR}/resfile.o)
else (MINGW)
      if (USE_ALSA)
            set (AUDIO ${AUDIO} alsa.cpp mididriver.cpp)
      endif (USE_ALSA)
endif (MINGW)

if (USE_PORTAUDIO)
      set (AUDIO ${AUDIO} pa.cpp)
endif (USE_PORTAUDIO)

if (USE_PORTMIDI)
      set (AUDIO ${AUDIO} pm.cpp)
endif (USE_PORTMIDI)

if (USE_JACK)
      set (AUDIO ${AUDIO} jackaudio.cpp jackweakapi.cpp)
endif (USE_JACK)

if (APPLE)
	set (ExecutableName mscore MACOSX_BUNDLE)
	set (MACOSX_BUNDLE_INFO_STRING MuseScore prerelease for Mac OSX)
	set (MACOSX_BUNDLE_ICON_FILE mscore.icns)
	set (MACOSX_BUNDLE_GUI_IDENTIFIER net.sourceforge.mscore)
	set (MACOSX_BUNDLE_LONG_VERSION_STRING ${Mscore_VERSION_FULL})
	set (MACOSX_BUNDLE_BUNDLE_NAME MuseScore)
	set (MACOSX_BUNDLE_SHORT_VERSION_STRING ${Mscore_VERSION})
	set (MACOSX_BUNDLE_BUNDLE_VERSION ${Mscore_VERSION_FULL})
	set (MACOSX_BUNDLE_COPYRIGHT musescore.org)
else (APPLE)
	set (ExecutableName mscore)
endif (APPLE)


add_executable ( ${ExecutableName}
      ${qrc_files}
      ${ui_headers}
      ${mocs}
      ${PROJECT_BINARY_DIR}/all.h
      ${PCH}
      ${resource_file}

      actions.cpp accidental.cpp barline.cpp beam.cpp
      bracket.cpp scoreview.cpp chord.cpp chordrest.cpp clef.cpp
      cmd.cpp dynamics.cpp edit.cpp editinstrument.cpp editstyle.cpp
      edittempo.cpp element.cpp exportxml.cpp file.cpp osc.cpp
      hairpin.cpp icons.cpp importbww.cpp importxml.cpp instrdialog.cpp
      key.cpp keyb.cpp layout.cpp layoutbreak.cpp line.cpp inspector.cpp
      measure.cpp menus.cpp midifile.cpp importmidi.cpp mscore.cpp
      navigate.cpp navigator.cpp note.cpp ottava.cpp
      page.cpp pagesettings.cpp palette.cpp part.cpp
      partedit.cpp pedal.cpp playpanel.cpp preferences.cpp measureproperties.cpp
      preview.cpp rest.cpp score.cpp segment.cpp select.cpp
      seq.cpp slur.cpp staff.cpp style.cpp instrtemplate.cpp boxproperties.cpp
      sym.cpp sym.h symbol.cpp symbol.h hook.cpp hook.h
      system.cpp text.cpp textline.cpp textpalette.cpp textstyle.cpp
      timedialog.cpp symboldialog.cpp trill.cpp tuplet.cpp shortcutcapturedialog.cpp
      undo.cpp utils.cpp xml.cpp timesig.cpp lyrics.cpp bsp.cpp
      volta.cpp simplebutton.cpp image.cpp keyfinder.cpp
      pitchspelling.cpp musedata.cpp keysig.cpp arpeggio.cpp breath.cpp
      glissando.cpp lilypond.cpp exportly.cpp box.cpp measurebase.cpp
      editdrumset.cpp editstaff.cpp drumset.cpp tremolo.cpp repeat.cpp
      voltaproperties.cpp chordproperties.cpp restproperties.cpp
      newwizard.cpp transposedialog.cpp bb.cpp
      harmony.cpp chordedit.cpp plugins.cpp tempotext.cpp
      excerptsdialog.cpp excerpt.cpp stafftext.cpp instrument.cpp durationtype.cpp
      event.cpp rendermidi.cpp articulation.cpp metaedit.cpp
      fifo.cpp spacer.cpp magbox.cpp voiceselector.cpp capella.cpp webpage.cpp
      scscore.cpp sccursor.cpp scchord.cpp scnote.cpp scpart.cpp sctext.cpp scmeasure.cpp scpageformat.cpp
      exportaudio.cpp repeatlist.cpp velo.cpp exportmidi.cpp textproperties.cpp
      screst.cpp scharmony.cpp slurproperties.cpp synthcontrol.cpp
      canonical.cpp drumroll.cpp pianoroll.cpp piano.cpp ruler.cpp pianoscene.cpp
      splitstaff.cpp scoretab.cpp keyedit.cpp harmonyedit.cpp updatechecker.cpp
      importove.cpp ove.cpp interval.cpp sctimesig.cpp musicxmlsupport.cpp
      ${AUDIO}
      )

# gold does not use indirect shared libraries for symbol resolution, Linux only
if (NOT MINGW AND NOT APPLE)
      if(USE_JACK)
        target_link_libraries(mscore dl)  
      endif(USE_JACK)
      target_link_libraries(mscore rt)
endif (NOT MINGW AND NOT APPLE)

if (STATIC_SCRIPT_BINDINGS)
      target_link_libraries(mscore
            qtscript_core
            qtscript_gui
            qtscript_network
            qtscript_uitools
            qtscript_xml)
endif (STATIC_SCRIPT_BINDINGS)

if (APPLE)
      set_target_properties (mscore PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${PROJECT_SOURCE_DIR}/packaging/MacOSXBundleInfo.plist.in)
endif(APPLE)

if (OSC)
    target_link_libraries(mscore ofqf)
endif (OSC)

if (MINGW)
   add_custom_command(
      OUTPUT ${PROJECT_BINARY_DIR}/resfile.o
      COMMAND ${QT_WRC_EXECUTABLE} -i mscore.rc -o ${PROJECT_BINARY_DIR}/mscore.res
      COMMAND ${QT_WINE_EXECUTABLE} /home/ws/.wine/drive_c/MingW/bin/windres.exe ${PROJECT_BINARY_DIR}/mscore.res -o ${PROJECT_BINARY_DIR}/resfile.o
      DEPENDS ${PROJECT_SOURCE_DIR}/mscore/data/mscore.rc
      WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/mscore/data
      )
   set_source_files_properties(
      ${PROJECT_BINARY_DIR}/resfile.o
      PROPERTIES generated true
      )
   # Windows: add -mconsole to LINK_FLAGS to get a console window for debug output
   if(CMAKE_BUILD_TYPE MATCHES "DEBUG")
     set_target_properties( mscore
        PROPERTIES
           COMPILE_FLAGS "-include ${PROJECT_BINARY_DIR}/all.h -g -Wall -Wextra -Winvalid-pch ${QT_DEFINITIONS} -DQT_SVG_LIB -DQT_GUI_LIB -DQT_XML_LIB -DQT_CORE_LIB -DQT_SCRIPT_LIB"
           LINK_FLAGS "${PROJECT_BINARY_DIR}/resfile.o -mwindows -mconsole -L ${CROSSQT}/lib"
        )
   else(CMAKE_BUILD_TYPE MATCHES "DEBUG")
     set_target_properties( mscore
          PROPERTIES
             COMPILE_FLAGS "-include ${PROJECT_BINARY_DIR}/all.h -Wall -Wextra -Winvalid-pch ${QT_DEFINITIONS} -DQT_SVG_LIB -DQT_GUI_LIB -DQT_XML_LIB -DQT_CORE_LIB -DQT_SCRIPT_LIB"
             LINK_FLAGS "-Wl,-S ${PROJECT_BINARY_DIR}/resfile.o -mwindows -L ${CROSSQT}/lib"
          )
   endif(CMAKE_BUILD_TYPE MATCHES "DEBUG")

   target_link_libraries(mscore
      fluid
      al
      awl
      bww
      osdabzip
      rtf2html
      qtsingleapp
      ${QT_mingw_LIBRARIES}
      portaudio
      portmidi
      winmm
      )

   if (HAS_AUDIOFILE)
      target_link_libraries(mscore libsndfile-1)
   endif (HAS_AUDIOFILE)

   install( TARGETS mscore RUNTIME DESTINATION bin )

   install_files ( /bin .dll
      ${CROSS}/bin/mingwm10.dll
      ${CROSS}/bin/libgcc_s_dw2-1.dll
      ${CROSS}/lib/portaudio.dll
      ${CROSS}/lib/libsndfile-1.dll
      ${CROSSQT}/bin/QtCore4.dll
      ${CROSSQT}/bin/QtGui4.dll
      ${CROSSQT}/bin/QtXml4.dll
      ${CROSSQT}/bin/QtSvg4.dll
      ${CROSSQT}/bin/QtScript4.dll
      ${CROSSQT}/bin/QtScriptTools4.dll
      ${CROSSQT}/bin/QtNetwork4.dll
      ${CROSSQT}/bin/QtWebKit4.dll
      ${CROSSQT}/bin/phonon4.dll
      )
   install_files ( /bin/iconengines .dll
      ${CROSSQT}/plugins/iconengines/qsvgicon4.dll
      )
   install_files ( /bin/imageformats .dll
      ${CROSSQT}/plugins/imageformats/qjpeg4.dll
      ${CROSSQT}/plugins/imageformats/qmng4.dll
      ${CROSSQT}/plugins/imageformats/qsvg4.dll
      ${CROSSQT}/plugins/imageformats/qtiff4.dll
      )

else (MINGW)
   set_target_properties( mscore
      PROPERTIES
         COMPILE_FLAGS "-include ${PROJECT_BINARY_DIR}/all.h ${QT_DEFINITIONS}"
      )
   target_link_libraries(mscore
      ${QT_LIBRARIES}
      ${QT_QTSCRIPT_LIBRARY_RELEASE}
      ${QT_QTSCRIPT_TOOLS_LIBRARY_RELEASE}
      ${ALSA_LIB}
      ${PORTAUDIO_LIB}
      al
      awl
      bww
      osdabzip
      rtf2html
      qtsingleapp
      fluid
      z
      )

   if (HAS_AUDIOFILE)
       target_link_libraries(mscore sndfile)
   endif (HAS_AUDIOFILE)

   if (APPLE)
     if (USE_PORTMIDI)
       target_link_libraries(mscore portmidi)
     endif (USE_PORTMIDI)
     target_link_libraries(mscore ${OsxFrameworks})
   endif (APPLE)

   if (QT45)
     target_link_libraries(mscore ${QT_QTSCRIPT_TOOLS_LIBRARY_RELEASE} )
   endif (QT45)

   if (APPLE)
     install (TARGETS mscore BUNDLE DESTINATION ${CMAKE_INSTALL_PREFIX})
     install (FILES data/mscore.icns DESTINATION ${Mscore_SHARE_NAME}${Mscore_INSTALL_NAME})
     install (FILES data/musescoreDocument.icns DESTINATION ${Mscore_SHARE_NAME}${Mscore_INSTALL_NAME})
   else (APPLE)
     install( TARGETS mscore RUNTIME DESTINATION bin )
     install( FILES   data/mscore.png DESTINATION share/pixmaps)
     install( FILES   data/mscore.xpm DESTINATION share/pixmaps)
   endif (APPLE)
endif (MINGW)

if (NOT MINGW AND NOT APPLE)
# command line utilities are not build for windows
#
#======================================
#     target smf2xml
#======================================

   add_executable(
      smf2xml
      ${ui_headers}

=== mscore/ofqf/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#  $Id:$
#
#  Copyright (C) 2010 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

include (${PROJECT_SOURCE_DIR}/cmake/gch.cmake)

QT4_WRAP_CPP (mocs
      qoscclient.h
      qoscserver.h
      qosctypes.h
      )

add_library(ofqf STATIC
   ${PROJECT_BINARY_DIR}/all.h
   ${PCH}
   ${mocs}
   qoscclient.cpp qoscserver.cpp qosctypes.cpp
   )

set_target_properties( ofqf
   PROPERTIES COMPILE_FLAGS "-include ${PROJECT_BINARY_DIR}/all.h -g -Wall -Wextra -Winvalid-pch"
   )

ADD_DEPENDENCIES(ofqf mops1)
ADD_DEPENDENCIES(ofqf mops2)

=== mscore/osdabzip/CMakeLists.txt ===
#=============================================================================
#  Mscore
#  Linux Music Score Editor
#  $Id:$
#
#  Copyright (C) 2008 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

include (${PROJECT_SOURCE_DIR}/cmake/gch.cmake)

add_library (
  osdabzip STATIC
  ${PROJECT_BINARY_DIR}/all.h
  ${PCH}  
  zip.cpp
  unzip.cpp
  )

set_target_properties( osdabzip
   PROPERTIES COMPILE_FLAGS "-include ${PROJECT_BINARY_DIR}/all.h -g -Wall -Wextra -Winvalid-pch"
   )

ADD_DEPENDENCIES(osdabzip mops1)
ADD_DEPENDENCIES(osdabzip mops2)

=== mscore/portmidi/CMakeLists.txt ===
#=============================================================================
#  Mscore
#  Linux Music Score Editor
#  $Id:$
#
#  Copyright (C) 2008 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

set(CMAKE_C_FLAGS "-DNEWBUFFER -DPMNULL")

if (APPLE)
  add_library (
    portmidi STATIC
        pm_common/pmutil.c
	pm_common/portmidi.c
	pm_mac/finddefault.c
	pm_mac/pmmac.c
	pm_mac/pmmacosxcm.c
	pm_mac/readbinaryplist.c
	porttime/porttime.c
	porttime/ptmacosx_mach.c
	porttime/ptmacosx_cf.c
  )
  include_directories(/Developer/Headers/FlatCarbon)
else (APPLE)
  add_library (
    portmidi STATIC
      pm_common/pmutil.c
      pm_win/pmwinmm.c
      pm_win/pmwin.c
	pm_common/portmidi.c
      porttime/porttime.c
      porttime/ptwinmm.c
  )
endif (APPLE)

include_directories(
      ${PROJECT_SOURCE_DIR}/portmidi/pm_common
      ${PROJECT_SOURCE_DIR}/portmidi/porttime
      )

=== debian/changelog ===
musescore (1.3+dfsg-1) unstable; urgency=low

  * New upstream release
    + see <http://musescore.org/en/musescore-1.3>
    + important bug fixes (Closes: #591908; LP: #1010457)
  * debian/control:
    + update long description for musescore-common
    + depend on mawk not gawk (Closes: #667845)
    + depend on individual libqtscript4 packages rather than the metapackage
      libqtscript4-qtbindings, since -opengl will not install on GNU/Hurd, thereby
      making musescore uninstallable
  * debian/patches:
    + drop 20-fix-dso-linking.patch
    + add 25-build-hurd.patch: add rules to CMakeLists to build on GNU or kFreeBSD

 -- Toby Smithe <tsmithe@ubuntu.com>  Wed, 19 Feb 2014 23:04:53 +0000

musescore (1.2+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches
    - add adjust-newer-freetype-header-location.patch (Closes: #733363)

 -- Hideki Yamane <henrich@debian.org>  Wed, 05 Feb 2014 21:19:03 +0900

=== debian/control ===
Source: musescore
Section: sound
Priority: optional
Maintainer: Toby Smithe <tsmithe@ubuntu.com>
Build-Depends: debhelper (>= 9), cmake, doxygen,
 graphviz, libqt4-dev (>= 4.6.0), libqtwebkit-dev, libasound2-dev, libjack-dev,
 libsndfile1-dev (>= 1.0.18), portaudio19-dev, zlib1g-dev, libfreetype6-dev,
 chrpath
Standards-Version: 3.9.5
Homepage: http://www.musescore.org/
Vcs-Bzr: http://bazaar.launchpad.net/~mscore-ubuntu/musescore/debian
Vcs-Browser: http://bazaar.launchpad.net/~mscore-ubuntu/musescore/debian/files

Package: musescore
Architecture: any
Provides: mscore
Replaces: mscore (<< 0.9.6+dfsg-1)
Conflicts: mscore (<< 0.9.6+dfsg-1)
Depends: ${misc:Depends}, ${shlibs:Depends}, musescore-common (>= 1.2+dfsg-0), 
 musescore-soundfont-gm, xdg-utils, desktop-file-utils, mawk, libqtscript4-core,
 libqtscript4-gui, libqtscript4-xml, libqtscript4-network, libqtscript4-uitools
Recommends: pulseaudio-utils
Suggests: fluid-soundfont-gm
Description: Full featured WYSIWYG score editor
 MuseScore is a free WYSIWYG music score typesetter for Linux,
 licenced under GNU GPL. Features:
  * WYSIWYG, notes are entered on a "virtual note sheet"
  * unlimited number of staves
  * up to four voices/staff
  * easy and fast note entry with mouse, keyboard or midi
  * integrated sequencer and FluidSynth software synthesizer
  * import and export of MusicXml and standard midifiles (SMF)
  * platform independent code for Linux, Windows and Mac
  
Package: musescore-common
Architecture: all
Depends: ${misc:Depends}
Provides: mscore-common
Replaces: mscore-common (<< 0.9.6+dfsg-1)
Conflicts: mscore-common (<< 0.9.6+dfsg-1)
Description: Full featured WYSIWYG score editor (common files)
 MuseScore is a free WYSIWYG music score typesetter for Linux,
 licenced under GNU GPL. Features:
  * WYSIWYG, notes are entered on a "virtual note sheet"
  * unlimited number of staves
  * up to four voices/staff
  * easy and fast note entry with mouse, keyboard or midi
  * integrated sequencer and FluidSynth software synthesizer
  * import and export of MusicXml and standard midifiles (SMF)
  * platform independent code for Linux, Windows and Mac
 .
 This package provides some files used by MuseScore, including demo
 scores, styles, templates, localisations, and some plugins.

Package: musescore-soundfont-gm
Architecture: all
Depends: ${misc:Depends}
Suggests: fluidsynth, timidity
Description: Small GM SoundFont for MuseScore (TimGM6mb)
 This is a GM SoundFont, for use with any modern MIDI synthesiser: hardware
 (like the emu10k1 sound card), or software (like FluidSynth).
 .
 This package provides the larger GM sound set, without the Roland Sound
 Canvas extensions.

Package: mscore
Architecture: all
Section: oldlibs
Priority: extra
Depends: ${misc:Depends}, musescore
Description: Dummy transitional package for musescore
 The package `mscore` has been renamed to `musescore`.
 .
 This is a dummy, transitional package which can be safely removed.

Package: mscore-common
Architecture: all
Section: oldlibs
Priority: extra
Depends: ${misc:Depends}, musescore-common
Description: Dummy transitional package for musescore-common
 The package `mscore-common` has been renamed to `musescore-common`.
 .
 This is a dummy, transitional package which can be safely removed.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp: configure-stamp 
	dh_testdir
	#cd mscore/manual && \
	#python ProcessHTML.py -o
	$(MAKE) PREFIX="/usr" release
	cp mscore/packaging/mscore.1 mscore/packaging/musescore.1
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	rm -f mscore/share/locale/mscore_*.qm
	rm -f mscore/manual/*.pyc mscore/manual/*.pdf mscore/manual/*.html
	rm -rf web
	$(MAKE) clean
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/musescore install

# Build architecture-independent files here.
binary-indep: build install

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs $(CURDIR)/mscore/ChangeLog
	dh_installdocs
	dh_install
	rm -r $(CURDIR)/debian/musescore/usr/share/mscore*
	cd $(CURDIR)/debian/musescore-common/usr/share && ln -s mscore-* mscore
	rm -r $(CURDIR)/debian/musescore-common/usr/share/mscore/sound
	mv $(CURDIR)/debian/musescore/usr/bin/mscore \
		$(CURDIR)/debian/musescore/usr/bin/mscore.real
	chrpath -d $(CURDIR)/debian/musescore/usr/bin/mscore.real
	install -T -m0755 $(CURDIR)/debian/mscore.sh \
		$(CURDIR)/debian/musescore/usr/bin/mscore
	dh_installman
	dh_installmenu
	dh_installmime
	dh_link
	dh_strip
	dh_icons
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch

get-orig-source: version = $(shell uscan --force-download --dehs --destdir . | sed -n 's/.*<upstream-version>\(.*\)<\/upstream-version>.*/\1/p')
get-orig-source:
	-mkdir tmp-musescore-$(version)
	tar -C tmp-musescore-$(version) -xjf mscore-$(version).tar.bz2
	cd tmp-musescore-$(version)/mscore* && \
	find -name *pdf -exec rm {} + && \
	rm mscore/rtf2html/rtf2html
	mv tmp-musescore-$(version)/mscore* \
	    tmp-musescore-$(version)/musescore-$(version)\+dfsg
	tar -C tmp-musescore-$(version) -czf musescore_$(version)\+dfsg.orig.tar.gz \
	    musescore-$(version)\+dfsg/
	#mv musescore_$(version)\+dfsg.orig.tar.gz ../
	rm -r tmp-musescore-$(version)
	-rm mscore*bz2 musescore*bz2

#this requires subversion
#get-orig-source: version = "0.9.6~beta1+dfsg"
#get-orig-source: revision = 2674
#get-orig-source:
#	svn co -r $(revision) https://mscore.svn.sourceforge.net/svnroot/mscore/trunk \
#	    musescore-$(version)
#	cd musescore-$(version) && \
#	    find -name *pdf -exec rm {} + && \
#	    find -name .svn -exec rm -rf {} +
#	tar czf musescore_$(version).orig.tar.gz musescore-$(version)/
#	rm -r musescore-$(version)

#### ----------------- Note on usage of below rules ------------------ ####
## The update-to-svn and build-svn rules are written from an Ubuntu	 ##
## perspective, designed to be able to automate the building of packages ##
## from svn for either Debian or Ubuntu systems, on Ubuntu systems.	 ##
## Apart from the standard coreutils and dephelper, the rules may	 ##
## require the following packages: svn, lsb-release, ubuntu-dev-tools	 ## 
## and python-pisa. By default, packages for Debian unstable are	 ##
## produced. If Ubuntu packages are required, set the environment	 ##
## variable "BUILD_UBUNTU". This will build for the currently running	 ##
## release by default; if you wish to build for any other, set the	 ##
## environment variable "UBUNTU_RELEASE" to the codename of that	 ## 
## release.								 ##
#### ----------------------------------------------------------------- ####

update-to-svn: version = $(shell svn up > /dev/null; make version)
update-to-svn: pkgdate = $(shell date +"%a, %d %b %Y %T %z")
update-to-svn:
	mv debian ..
	find -name *pdf -exec rm {} +
	-rm mscore/rtf2html/rtf2html
	cp -r . ../svn-musescore-$(version)
	cd ../svn-musescore-$(version) && find -name .svn -exec rm -rf {} +
	if [ ! -e ../musescore_$(version)+dfsg.orig.tar.gz ]; then \
		tar czf ../musescore_$(version)+dfsg.orig.tar.gz ../svn-musescore-$(version); \
	fi
	rm -rf ../svn-musescore-$(version)
	mv ../debian .
	#cp -r ./debian ../svn-musescore-$(version)/
	mv debian/changelog debian/changelog.old
	if [ "$(BUILD_UBUNTU)" -o "$(UBUNTU_RELEASE)" ]; then \
		if [ "$(UBUNTU_RELEASE)" ]; then \
			echo "musescore ($(version)+dfsg-0ubuntu~$(UBUNTU_RELEASE)1) $(UBUNTU_RELEASE); urgency=low" > debian/changelog.new; \
		else \
			echo "musescore ($(version)+dfsg-0ubuntu~$(shell lsb_release -sc)1) $(shell lsb_release -sc); urgency=low" > debian/changelog.new; \
		fi; \
	else \
		echo "musescore ($(version)+dfsg-1) unstable; urgency=low" > debian/changelog.new; \
	fi
	echo >> debian/changelog.new
	echo "	* New svn revision" >> debian/changelog.new
	echo >> debian/changelog.new
	echo " -- Toby Smithe <tsmithe@ubuntu.com>  $(pkgdate)" >> debian/changelog.new
	echo >> debian/changelog.new
	cat debian/changelog.new debian/changelog.old > debian/changelog
	rm debian/changelog.new debian/changelog.old

build-svn: version = $(shell dpkg-parsechangelog -n0 | grep Version | cut -c10-)
build-svn: dist = $(shell dpkg-parsechangelog -n0 | grep Distribution | cut -c15-)
build-svn: update-to-svn
	debuild --no-tgz-check -S -sa -i".svn"\|"/.svn"\|"/.bzr" -k3939EBEE
	cd .. && \
	pbuilder-dist $(dist) build musescore_$(version).dsc

.PHONY: update-to-svn build-svn build-manuals get-orig-source build clean binary-indep binary-arch binary install configure
